=== docs/technical_manual/Makefile ===
SRC = 	technical_manual.tex \
	convention.tex \
	DataStructure.tex \
	introduction.tex \
	interface.tex \
	render.tex \
	render_svg.tex \
	ParserOTF.tex \
	ParserViTE.tex \
	ParserPaje.tex \
	plugin.tex

DOC =	technical_manual

.PHONY	= clean cleanout cleanall

default	: $(DOC).pdf

$(DOC).pdf :  $(DOC).dvi
	dvipdf $(DOC).dvi

$(DOC).dvi :  $(SRC)
	latex $(DOC).tex
	latex $(DOC).tex
	latex $(DOC).tex

clean :
	rm -f *~ *.aux *.log *.toc *.out

cleanout :
	rm -f $(DOC).dvi $(DOC).pdf

cleanall : clean cleanout
