=== tests/render/Makefile ===
test_ruler: test_Ruler.cpp
	g++ -c test_Ruler.cpp -o test_Ruler.o
	g++ -o test_Ruler test_Ruler.o ../../bin/Ruler.o

render_test: main.cpp Render.hpp Render_opengl.hpp Trace.hpp
	g++ -c Render.hpp -o Render.o
	g++ -c Render_opengl.hpp -o Render_opengl.o
	g++ -c Trace.hpp -o Trace.o
	g++ main.cpp -o render_test -LRender.o -LRender_opengl.o -LTrace.o

clean:
	rm *.o
	rm render_test
	rm test_Ruler
	rm *~
