=== debian/changelog ===
vite (1.4-6) unstable; urgency=medium

  [ Samuel Thibault ]
  * watch: Leverage v5.

  [ Philippe SWARTVAGHER ]
  * patches/supertabular: drop, fix applied upstream (Closes: Bug#1126647)
  * control: add myself as uploader
  * control: Bump Standards-Version to 4.7.3:
    + Drop now spurious Rules-Requires-Root
    + Drop now spurious Priority
  * patches/git-cmake4: add "Forwarded" field
  * Add patches/use-svg-icon.patch to ship a SVG icon in the right folder
  * Add patches/metainfo.patch to ship a metainfo file
  * Add superficial autopktest

 -- Philippe SWARTVAGHER <phil.swart@gmx.fr>  Sun, 01 Feb 2026 15:02:09 +0100

vite (1.4-5) unstable; urgency=medium

  * copyright: Updated.
  * patches/git-cmake4: Fix build against cmake 4 (Closes: Bug#1113622)

 -- Samuel Thibault <sthibault@debian.org>  Mon, 01 Sep 2025 01:17:43 +0200

vite (1.4-4) unstable; urgency=medium

  * control: Enable otf2 build-dep on all archs but hurd-any
    (Closes: Bug#1111271)

 -- Samuel Thibault <sthibault@debian.org>  Sun, 17 Aug 2025 09:51:36 +0200

vite (1.4-3) unstable; urgency=medium

  * control: Enable otf2 build-dep on all archs but hurd-any
    (Closes: Bug#1111271)

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 22:56:09 +0200

vite (1.4-2) unstable; urgency=medium

  * copyright: Update.
  * patches/supertabular: Fix compilation with texlive 2025.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 16 Aug 2025 02:11:18 +0200

vite (1.4-1) unstable; urgency=medium

  * New upstream release
    - Remove all patches, all being applied upstream
  * rules: remove now spurious -D flags
  * rules: build with hardening+=all
  * control: Bump Standards-Version to 4.7.0 (no change)
  * control: Update homepage
  * control: do not build-depend on otf1 (dropped support upstream)
  * copyright: update and convert to DEP5 format
  * Add d/upstream/metadata
  * docs: do not build and ship technical manual anymore
  * Add d/doc-base
  * Remove d/install, upstream now installs everything
  * Remove d/vite.desktop, now installed by upstream
  * Build and ship also vite-vbo, VBO version of vite
  * Add d/watch

 -- Philippe SWARTVAGHER <phil.swart@gmx.fr>  Thu, 25 Jul 2024 12:54:08 +0200

vite (1.2+svn+git4.c6c0ce7-8) unstable; urgency=medium

  * rules: Disable OTF2 on archs where it is not available.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 19:38:32 +0100

vite (1.2+svn+git4.c6c0ce7-7) unstable; urgency=medium

  * control: Fix arch exclusion.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 13:30:51 +0100

vite (1.2+svn+git4.c6c0ce7-6) unstable; urgency=medium

  * control: Drop otf2 support on archs which don't have the atomics required
    by otf2.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 13:02:55 +0100
