=== debian/watch ===
Version: 5

Source: https://gitlab.inria.fr/solverstack/@PACKAGE@
Mode: gitlab
Matching-Pattern: @ANY_VERSION@
Uversion-Mangle: s/^v//
